// Code generated by tygo. DO NOT EDIT.
import * as MautrixID from "../../../../../maunium.net/go/mautrix/id/index.ts"
import * as MautrixBridgeV2 from "../../../../../maunium.net/go/mautrix/bridgev2/index.ts"
import * as MautrixEvent from "../../../../../maunium.net/go/mautrix/event/index.ts"
import * as MautrixBridgeV2Commands from "../../../../../maunium.net/go/mautrix/bridgev2/commands/index.ts"
import * as MautrixBridgeV2NetworkID from "../../../../../maunium.net/go/mautrix/bridgev2/networkid/index.ts"
import * as MautrixBridgeStatus from "../../../../../maunium.net/go/mautrix/bridge/status/index.ts"
import * as BeeperSDKBridgesTypes from "../../pkg/bridges/types/index.ts"
//////////
// source: account.go

export interface AccountQuery {
}
export interface Account {
  user_id: MautrixID.UserID;
  device_id: MautrixID.DeviceID;
  access_token: string;
  homeserver: string;
}

//////////
// source: account_ids.go

export interface AccountIDQuery {
}

//////////
// source: backup_retry.go

export interface BackupRetryQuery {
}
export interface LocalBackupRetry {
  RowID: number /* int64 */;
  RoomID: MautrixID.RoomID;
  Created: any /* jsontime.UnixMilli */;
  Data: string;
}

//////////
// source: database.go

export const DefaultType = "sqlite3-fk-wal";
export const DefaultQueryParams = "_txlock=immediate";
export interface Database {
  Account?: AccountQuery;
  AccountID?: AccountIDQuery;
  Store?: StoreQuery;
  Decryption?: DecryptionQuery;
  Pagination?: PaginationQuery;
  BackupRetry?: BackupRetryQuery;
  LocalEvents?: LocalEventQuery;
  LocalReceipts?: LocalReceiptQuery;
  LocalBridgeState?: LocalBridgeStateQuery;
  LocalRoomAccountData?: LocalRoomAccountDataQuery;
  Upgrades?: UpgradesQuery;
  Verifications?: VerificationsQuery;
  SentMessageFlightTracker?: SentMessageFlightTrackerQuery;
}

//////////
// source: decryption.go

export interface DecryptionQuery {
}
export interface Decryption {
  RoomID: MautrixID.RoomID;
  EventID: MautrixID.EventID;
  Sender: MautrixID.UserID;
  StateKey?: string;
  Content: string;
  Unsigned: string;
  Timestamp: any /* jsontime.UnixMilli */;
  FailedCount: number /* int */;
  Created: any /* jsontime.UnixMilli */;
  Backoff: any /* jsontime.UnixMilli */;
}

//////////
// source: flight_tracker.go

export interface SentMessageFlightTrackerQuery {
}
/**
 * FlightTrackerEvent represents an event that's in flight to the Matrix network
 */
export interface FlightTrackerEvent {
  Event?: MautrixEvent.Event;
  TransactionID: string;
  BridgeID: BeeperSDKBridgesTypes.BridgeID;
  AddedAt: string /* RFC3339 */;
}

//////////
// source: local_bridge_state.go

export interface LocalBridgeStateQuery {
}
export interface LocalBridgeState {
  bridge_id: BeeperSDKBridgesTypes.BridgeID;
  account_id: any /* types.AccountID */;
  profile_data?: string;
  state?: MautrixBridgeStatus.BridgeStateEvent;
  timestamp?: any /* jsontime.UnixMilli */;
  err_code?: MautrixBridgeStatus.BridgeStateErrorCode;
  error?: string;
}
export interface LocalBridgeStateQueueItem {
  LocalBridgeState: LocalBridgeState;
  RowID: number /* int64 */;
}

//////////
// source: local_events.go

export interface LocalEventQuery {
}
/**
 * LocalEvent represents a local bridge event, which may have come from cloud backup or a bridge
 * running on this device.
 */
export interface LocalEvent {
  RoomID: MautrixID.RoomID;
  EventID: MautrixID.EventID;
  Sender: MautrixID.UserID;
  Type: string;
  StateKey?: string;
  Content: string;
  Redacts?: MautrixID.EventID;
  Unsigned: string;
  StreamOrder: number /* int64 */;
  StreamSuborder: number /* int16 */;
  Timestamp: any /* jsontime.UnixMilli */;
  Created: any /* jsontime.UnixMilli */;
  BackedUp?: any /* jsontime.UnixMilli */;
  BackupBackoff?: any /* jsontime.UnixMilli */;
}

//////////
// source: local_receipts.go

export interface LocalReceiptQuery {
}
/**
 * LocalReceipt represents a local bridge receipt, which may have come from cloud backup or a bridge
 * running on this device. Unlike LocalEvent receipts are mutable and will be overwritten by newer
 * receipts.
 */
export interface LocalReceipt {
  RowID: number /* int64 */;
  RoomID: MautrixID.RoomID;
  Sender: MautrixID.UserID;
  EventID: MautrixID.EventID;
  StreamOrder: number /* int64 */;
  StreamSuborder: number /* int16 */;
  Timestamp: any /* jsontime.UnixMilli */;
  BackedUp?: any /* jsontime.UnixMilli */;
  BackupBackoff?: any /* jsontime.UnixMilli */;
}

//////////
// source: local_room_account_data.go

export interface LocalRoomAccountDataQuery {
}
export interface LocalRoomAccountData {
  room_id: MautrixID.RoomID;
  type: string;
  content: string;
}

//////////
// source: pagination.go

export interface PaginationQuery {
}

//////////
// source: store.go

export interface StoreQuery {
}
export type ValueIterFunc = any;
export const NextBatchKey = "nextbatch";
export const UIAuthDataKey = "uiauthdata";

//////////
// source: upgrades.go

export interface UpgradesQuery {
}

//////////
// source: verifications.go

export interface VerificationsQuery {
}
