// Code generated by tygo. DO NOT EDIT.
import * as MautrixID from "../id/index.ts"
import * as MautrixBridgeV2 from "../bridgev2/index.ts"
import * as MautrixEvent from "../event/index.ts"
import * as MautrixBridgeV2Commands from "../bridgev2/commands/index.ts"
import * as MautrixBridgeV2NetworkID from "../bridgev2/networkid/index.ts"
import * as MautrixBridgeStatus from "../bridge/status/index.ts"
import * as BeeperSDKBridgesTypes from "../../../../github.com/beeper/beeper-client-sdk/pkg/bridges/types/index.ts"
//////////
// source: backfillqueue.go

export const BackfillMinBackoffAfterRoomCreate = 1 * any /* time.Minute */;
export const BackfillQueueErrorBackoff = 1 * any /* time.Minute */;
export const BackfillQueueMaxEmptyBackoff = 10 * any /* time.Minute */;

//////////
// source: bridge.go

export type CommandProcessor = any;
export interface Bridge {
  ID: any /* networkid.BridgeID */;
  DB?: any /* database.Database */;
  Log: any /* zerolog.Logger */;
  Matrix: MatrixConnector;
  Bot: MatrixAPI;
  Network: NetworkConnector;
  Commands: CommandProcessor;
  Config?: any /* bridgeconfig.BridgeConfig */;
  DisappearLoop?: DisappearLoop;
  Background: boolean;
  ExternallyManagedDB: boolean;
  BackgroundCtx: any /* context.Context */;
}
export interface DBUpgradeError {
  Err: error;
  Section: string;
}

//////////
// source: bridgestate.go

export interface BridgeStateQueue {
}

//////////
// source: disappear.go

export interface DisappearLoop {
  NextCheck: string /* RFC3339 */;
}
export const DisappearCheckInterval = 1 * any /* time.Hour */;

//////////
// source: errors.go

/**
 * RespError is a class of error that certain network interface methods can return to ensure that the error
 * is properly translated into an HTTP error when the method is called via the provisioning API.
 * However, unlike mautrix.RespError, this does not include the error code
 * in the message shown to users when used outside HTTP contexts.
 */
export type RespError = any /* mautrix.RespError */;

//////////
// source: ghost.go

export interface Ghost {
  Ghost?: any /* database.Ghost */;
  Bridge?: Bridge;
  Log: any /* zerolog.Logger */;
  Intent: MatrixAPI;
}
export interface Avatar {
  ID: any /* networkid.AvatarID */;
  Get: any;
  Remove: boolean;
  /**
   * For pre-uploaded avatars, the MXC URI and hash can be provided directly
   */
  MXC: MautrixID.ContentURIString;
  Hash: string;
}
export interface UserInfo {
  Identifiers: string[];
  Name?: string;
  Avatar?: Avatar;
  IsBot?: boolean;
  ExtraUpdates: ExtraUpdater<Ghost | undefined>;
}

//////////
// source: login.go

/**
 * LoginProcess represents a single occurrence of a user logging into the remote network.
 */
export type LoginProcess = any;
export type LoginProcessWithOverride =
    LoginProcess;
export type LoginProcessDisplayAndWait =
    LoginProcess;
export type LoginProcessUserInput =
    LoginProcess;
export type LoginProcessCookies =
    LoginProcess;
export interface LoginFlow {
  name: string;
  description: string;
  id: string;
}
export type LoginStepType = string;
export const LoginStepTypeUserInput: LoginStepType = "user_input";
export const LoginStepTypeCookies: LoginStepType = "cookies";
export const LoginStepTypeDisplayAndWait: LoginStepType = "display_and_wait";
export const LoginStepTypeComplete: LoginStepType = "complete";
export type LoginDisplayType = string;
export const LoginDisplayTypeQR: LoginDisplayType = "qr";
export const LoginDisplayTypeEmoji: LoginDisplayType = "emoji";
export const LoginDisplayTypeCode: LoginDisplayType = "code";
export const LoginDisplayTypeNothing: LoginDisplayType = "nothing";
export interface LoginStep {
  /**
   * The type of login step
   */
  type: LoginStepType;
  /**
   * A unique ID for this step. The ID should be same for every login using the same flow,
   * but it should be different for different bridges and step types.
   * For example, Telegram's QR scan followed by a 2-factor password
   * might use the IDs `fi.mau.telegram.qr` and `fi.mau.telegram.2fa_password`.
   */
  step_id: string;
  /**
   * Instructions contains human-readable instructions for completing the login step.
   */
  instructions: string;
  display_and_wait?: LoginDisplayAndWaitParams;
  cookies?: LoginCookiesParams;
  user_input?: LoginUserInputParams;
  complete?: LoginCompleteParams;
}
export interface LoginDisplayAndWaitParams {
  /**
   * The type of thing to display (QR, emoji or text code)
   */
  type: LoginDisplayType;
  /**
   * The thing to display (raw data for QR, unicode emoji for emoji, plain string for code, omitted for nothing)
   */
  data?: string;
  /**
   * An image containing the thing to display. If present, this is recommended over using data directly.
   * For emojis, the URL to the canonical image representation of the emoji
   */
  image_url?: string;
}
export type LoginCookieFieldSourceType = string;
export const LoginCookieTypeCookie: LoginCookieFieldSourceType = "cookie";
export const LoginCookieTypeLocalStorage: LoginCookieFieldSourceType = "local_storage";
export const LoginCookieTypeRequestHeader: LoginCookieFieldSourceType = "request_header";
export const LoginCookieTypeRequestBody: LoginCookieFieldSourceType = "request_body";
export const LoginCookieTypeSpecial: LoginCookieFieldSourceType = "special";
export interface LoginCookieFieldSource {
  /**
   * The type of source.
   */
  type: LoginCookieFieldSourceType;
  /**
   * The name of the field. The exact meaning depends on the type of source.
   * Cookie:         cookie name
   * Local storage:  key in local storage
   * Request header: header name
   * Request body:   field name inside body after it's parsed (as JSON or multipart form data)
   * Special:        a namespaced identifier that clients can implement special handling for
   */
  name: string;
  /**
   * For request header & body types, a regex matching request URLs where the value can be extracted from.
   */
  request_url_regex?: string;
  /**
   * For cookie types, the domain the cookie is present on.
   */
  cookie_domain?: string;
}
export interface LoginCookieField {
  /**
   * The key in the map that is submitted to the connector.
   */
  id: string;
  required: boolean;
  /**
   * The sources that can be used to acquire the field value. Only one of these needs to be used.
   */
  sources: LoginCookieFieldSource[];
  /**
   * A regex pattern that the client can use to validate value client-side.
   */
  pattern?: string;
}
export interface LoginCookiesParams {
  url: string;
  user_agent?: string;
  /**
   * The fields that are needed for this cookie login.
   */
  fields: LoginCookieField[];
  /**
   * A JavaScript snippet that can extract some or all of the fields.
   * The snippet will evaluate to a promise that resolves when the relevant fields are found.
   * Fields that are not present in the promise result must be extracted another way.
   */
  extract_js?: string;
  /**
   * A regex pattern that the URL should match before the client closes the webview.
   * The client may submit the login if the user closes the webview after all cookies are collected
   * even if this URL is not reached, but it should only automatically close the webview after
   * both cookies and the URL match.
   */
  wait_for_url_pattern?: string;
}
export type LoginInputFieldType = string;
export const LoginInputFieldTypeUsername: LoginInputFieldType = "username";
export const LoginInputFieldTypePassword: LoginInputFieldType = "password";
export const LoginInputFieldTypePhoneNumber: LoginInputFieldType = "phone_number";
export const LoginInputFieldTypeEmail: LoginInputFieldType = "email";
export const LoginInputFieldType2FACode: LoginInputFieldType = "2fa_code";
export const LoginInputFieldTypeToken: LoginInputFieldType = "token";
export const LoginInputFieldTypeURL: LoginInputFieldType = "url";
export const LoginInputFieldTypeDomain: LoginInputFieldType = "domain";
export interface LoginInputDataField {
  /**
   * The type of input field as a hint for the client.
   */
  type: LoginInputFieldType;
  /**
   * The ID of the field to be used as the key in the map that is submitted to the connector.
   */
  id: string;
  /**
   * The name of the field shown to the user.
   */
  name: string;
  /**
   * The description of the field shown to the user.
   */
  description: string;
  /**
   * A regex pattern that the client can use to validate input client-side.
   */
  pattern?: string;
}
export interface LoginUserInputParams {
  /**
   * The fields that the user needs to fill in.
   */
  fields: LoginInputDataField[];
}
export interface LoginCompleteParams {
  user_login_id: MautrixBridgeV2NetworkID.UserLoginID;
}
export interface LoginSubmit {
}

//////////
// source: matrixinterface.go

export interface MatrixCapabilities {
  AutoJoinInvites: boolean;
  BatchSending: boolean;
}
export type MatrixConnector = any;
export type MatrixConnectorWithServer = any;
export type MatrixConnectorWithPublicMedia = any;
export type MatrixConnectorWithNameDisambiguation = any;
export type MatrixConnectorWithBridgeIdentifier = any;
export type MatrixConnectorWithURLPreviews = any;
export type MatrixConnectorWithPostRoomBridgeHandling = any;
export type MatrixConnectorWithAnalytics = any;
export interface DirectNotificationData {
  Portal?: Portal;
  Sender?: Ghost;
  MessageID: any /* networkid.MessageID */;
  Message: string;
  FormattedNotification: string;
  FormattedTitle: string;
}
export type MatrixConnectorWithNotifications = any;
export interface MatrixSendExtra {
  Timestamp: string /* RFC3339 */;
  MessageMeta?: any /* database.Message */;
  ReactionMeta?: any /* database.Reaction */;
  StreamOrder: number /* int64 */;
  PartIndex: number /* int */;
}
/**
 * FileStreamResult is the result of a FileStreamCallback.
 */
export interface FileStreamResult {
  /**
   * ReplacementFile is the path to a new file that replaces the original file provided to the callback.
   * Providing a replacement file is only allowed if the requireFile flag was set for the UploadMediaStream call.
   */
  ReplacementFile: string;
  /**
   * FileName is the name of the file to be specified when uploading to the server.
   * This should be the same as the file name that will be included in the Matrix event (body or filename field).
   * If the file gets encrypted, this field will be ignored.
   */
  FileName: string;
  /**
   * MimeType is the type of field to be specified when uploading to the server.
   * This should be the same as the mime type that will be included in the Matrix event (info -> mimetype field).
   * If the file gets encrypted, this field will be replaced with application/octet-stream.
   */
  MimeType: string;
}
/**
 * FileStreamCallback is a callback function for file uploads that roundtrip via disk.
 * The parameter is either a file or an in-memory buffer depending on the size of the file and whether the requireFile flag was set.
 * The return value must be non-nil unless there's an error, and should always include FileName and MimeType.
 */
export type FileStreamCallback = any;
export interface CallbackError {
  Type: string;
  Wrapped: error;
}
export type MatrixAPI = any;
export type MarkAsDMMatrixAPI = any;

//////////
// source: messagestatus.go

export interface MessageStatusEventInfo {
  RoomID: MautrixID.RoomID;
  SourceEventID: MautrixID.EventID;
  NewEventID: MautrixID.EventID;
  EventType: MautrixEvent.Type;
  MessageType: any /* event.MessageType */;
  Sender: MautrixID.UserID;
  ThreadRoot: MautrixID.EventID;
  StreamOrder: number /* int64 */;
  IsSourceEventDoublePuppeted: boolean;
}
/**
 * MessageStatus represents the status of a message. It also implements the error interface to allow network connectors
 * to return errors which get translated into user-friendly error messages and/or status events.
 */
export interface MessageStatus {
  Step: any /* status.MessageCheckpointStep */;
  RetryNum: number /* int */;
  Status: any /* event.MessageStatus */;
  ErrorReason: any /* event.MessageStatusReason */;
  DeliveredTo: MautrixID.UserID[];
  InternalError: error; // Internal error to be tracked in message checkpoints
  Message: string; // Human-readable message shown to users
  ErrorAsMessage: boolean;
  IsCertain: boolean;
  SendNotice: boolean;
  DisableMSS: boolean;
}

//////////
// source: networkinterface.go

export interface ConvertedMessagePart {
  ID: any /* networkid.PartID */;
  Type: MautrixEvent.Type;
  Content?: any /* event.MessageEventContent */;
  Extra: { [key: string]: any};
  DBMetadata: any;
  DontBridge: boolean;
}
/**
 * EventSender represents a specific user in a chat.
 */
export interface EventSender {
  /**
   * If IsFromMe is true, the UserLogin who the event was received through is used as the sender.
   * Double puppeting will be used if available.
   */
  IsFromMe: boolean;
  /**
   * SenderLogin is the ID of the UserLogin who sent the event. This may be different from the
   * login the event was received through. It is used to ensure double puppeting can still be
   * used even if the event is received through another login.
   */
  SenderLogin: MautrixBridgeV2NetworkID.UserLoginID;
  /**
   * Sender is the remote user ID of the user who sent the event.
   * For new events, this will not be used for double puppeting.
   * However, in the member list, [ChatMemberList.CheckAllLogins] can be specified to go through every login
   * and call [NetworkAPI.IsThisUser] to check if this ID belongs to that login. This method is not recommended,
   * it is better to fill the IsFromMe and SenderLogin fields appropriately.
   */
  Sender: MautrixBridgeV2NetworkID.UserID;
  /**
   * ForceDMUser can be set if the event should be sent as the DM user even if the Sender is different.
   * This only applies in DM rooms where [database.Portal.OtherUserID] is set and is ignored if IsFromMe is true.
   * A warning will be logged if the sender is overridden due to this flag.
   */
  ForceDMUser: boolean;
}
export interface ConvertedMessage {
  ReplyTo?: any /* networkid.MessageOptionalPartID */;
  ThreadRoot?: any /* networkid.MessageID */;
  Parts: (ConvertedMessagePart | undefined)[];
  Disappear: any /* database.DisappearingSetting */;
}
export interface ConvertedEditPart {
  Part?: any /* database.Message */;
  Type: MautrixEvent.Type;
  /**
   * The Content and Extra fields will be put inside `m.new_content` automatically.
   * SetEdit must NOT be called by the network connector.
   */
  Content?: any /* event.MessageEventContent */;
  Extra: { [key: string]: any};
  /**
   * TopLevelExtra can be used to specify custom fields at the top level of the content rather than inside `m.new_content`.
   */
  TopLevelExtra: { [key: string]: any};
  /**
   * NewMentions can be used to specify new mentions that should ping the users again.
   * Mentions inside the edited content will not ping.
   */
  NewMentions?: any /* event.Mentions */;
  DontBridge: boolean;
}
export interface ConvertedEdit {
  ModifiedParts: (ConvertedEditPart | undefined)[];
  DeletedParts: (any /* database.Message */ | undefined)[];
  /**
   * Warning: added parts will be sent at the end of the room.
   * If other messages have been sent after the message being edited,
   * these new parts will not be next to the existing parts.
   */
  AddedParts?: ConvertedMessage;
}
/**
 * BridgeName contains information about the network that a connector bridges to.
 */
export interface BridgeName {
  /**
   * The displayname of the network, e.g. `Discord`
   */
  displayname: string;
  /**
   * The URL to the website of the network, e.g. `https://discord.com`
   */
  network_url: string;
  /**
   * The icon of the network as a mxc:// URI
   */
  network_icon: MautrixID.ContentURIString;
  /**
   * An identifier uniquely identifying the network, e.g. `discord`
   */
  network_id: string;
  /**
   * An identifier uniquely identifying the bridge software.
   * The Go import path is a good choice here (e.g. github.com/octocat/discordbridge)
   */
  beeper_bridge_type: string;
  /**
   * The default appservice port to use in the example config, defaults to 8080 if unset
   * Official mautrix bridges will use ports defined in https://mau.fi/ports
   */
  default_port?: number /* uint16 */;
  /**
   * The default command prefix to use in the example config, defaults to NetworkID if unset. Must include the ! prefix.
   */
  default_command_prefix?: string;
}
/**
 * NetworkConnector is the main interface that a network connector must implement.
 */
export type NetworkConnector = any;
export type StoppableNetwork = any;
/**
 * DirectMediableNetwork is an optional interface that network connectors can implement to support direct media access.
 * If the Matrix connector has direct media enabled, SetUseDirectMedia will be called
 * before the Start method of the network connector. Download will then be called
 * whenever someone wants to download a direct media `mxc://` URI which was generated
 * by calling GenerateContentURI on the Matrix connector.
 */
export type DirectMediableNetwork =
    NetworkConnector;
/**
 * IdentifierValidatingNetwork is an optional interface that network connectors can implement to validate the shape of user IDs.
 * This should not perform any checks to see if the user ID actually exists on the network, just that the user ID looks valid.
 */
export type IdentifierValidatingNetwork =
    NetworkConnector;
export type TransactionIDGeneratingNetwork =
    NetworkConnector;
export type PortalBridgeInfoFillingNetwork =
    NetworkConnector;
/**
 * ConfigValidatingNetwork is an optional interface that network connectors can implement to validate config fields
 * before the bridge is started.
 * When the ValidateConfig method is called, the config data will already be unmarshaled into the
 * object returned by [NetworkConnector.GetConfig].
 * This mechanism is usually used to refuse bridge startup if a mandatory field has an invalid value.
 */
export type ConfigValidatingNetwork =
    NetworkConnector;
/**
 * MaxFileSizeingNetwork is an optional interface that network connectors can implement
 * to find out the maximum file size that can be uploaded to Matrix.
 * The SetMaxFileSize will be called asynchronously soon after startup.
 * Before the function is called, the connector may assume a default limit of 50 MiB.
 */
export type MaxFileSizeingNetwork =
    NetworkConnector;
export type RemoteEchoHandler = any;
export interface MatrixMessageResponse {
  DB?: any /* database.Message */;
  StreamOrder: number /* int64 */;
  /**
   * If Pending is set, the bridge will not save the provided message to the database.
   * This should only be used if AddPendingToSave has been called.
   */
  Pending: boolean;
  /**
   * If RemovePending is set, the bridge will remove the provided transaction ID from pending messages
   * after saving the provided message to the database. This should be used with AddPendingToIgnore.
   */
  RemovePending: any /* networkid.TransactionID */;
  /**
   * An optional function that is called after the message is saved to the database.
   * Will not be called if the message is not saved for some reason.
   */
  PostSave: any;
}
export interface OutgoingTimeoutConfig {
  CheckInterval: any /* time.Duration */;
  NoEchoTimeout: any /* time.Duration */;
  NoEchoMessage: string;
  NoAckTimeout: any /* time.Duration */;
  NoAckMessage: string;
}
export interface NetworkGeneralCapabilities {
  /**
   * Does the network connector support disappearing messages?
   * This flag enables the message disappearing loop in the bridge.
   */
  DisappearingMessages: boolean;
  /**
   * Should the bridge re-request user info on incoming messages even if the ghost already has info?
   * By default, info is only requested for ghosts with no name, and other updating is left to events.
   */
  AggressiveUpdateInfo: boolean;
  /**
   * If the bridge uses the pending message mechanism ([MatrixMessage.AddPendingToSave])
   * to handle asynchronous message responses, this field can be set to enable
   * automatic timeout errors in case the asynchronous response never arrives.
   */
  OutgoingMessageTimeouts?: OutgoingTimeoutConfig;
}
/**
 * NetworkAPI is an interface representing a remote network client for a single user login.
 * Implementations of this interface are stored in [UserLogin.Client].
 * The [NetworkConnector.LoadUserLogin] method is responsible for filling the Client field with a NetworkAPI.
 */
export type NetworkAPI = any;
export interface ConnectBackgroundParams {
  /**
   * RawData is the raw data in the push that triggered the background connection.
   */
  RawData: any /* json.RawMessage */;
  /**
   * ExtraData is the data returned by [PushParsingNetwork.ParsePushNotification].
   * It's only present for native pushes. Relayed pushes will only have the raw data.
   */
  ExtraData: any;
}
/**
 * BackgroundSyncingNetworkAPI is an optional interface that network connectors can implement to support background resyncs.
 */
export type BackgroundSyncingNetworkAPI =
    NetworkAPI;
/**
 * FetchMessagesParams contains the parameters for a message history pagination request.
 */
export interface FetchMessagesParams {
  /**
   * The portal to fetch messages in. Always present.
   */
  Portal?: Portal;
  /**
   * When fetching messages inside a thread, the ID of the thread.
   */
  ThreadRoot: any /* networkid.MessageID */;
  /**
   * Whether to fetch new messages instead of old ones.
   */
  Forward: boolean;
  /**
   * The oldest known message in the thread or the portal. If Forward is true, this is the newest known message instead.
   * If the portal doesn't have any bridged messages, this will be nil.
   */
  AnchorMessage?: any /* database.Message */;
  /**
   * The cursor returned by the previous call to FetchMessages with the same portal and thread root.
   * This will not be present in Forward calls.
   */
  Cursor: any /* networkid.PaginationCursor */;
  /**
   * The preferred number of messages to return. The returned batch can be bigger or smaller
   * without any side effects, but the network connector should aim for this number.
   */
  Count: number /* int */;
  /**
   * When a forward backfill is triggered by a [RemoteChatResyncBackfillBundle], this will contain
   * the bundled data returned by the event. It can be used as an optimization to avoid fetching
   * messages that were already provided by the remote network, while still supporting fetching
   * more messages if the limit is higher.
   */
  BundledData: any;
  /**
   * When the messages are being fetched for a queued backfill, this is the task object.
   */
  Task?: any /* database.BackfillTask */;
}
/**
 * BackfillReaction is an individual reaction to a message in a history pagination request.
 * The target message is always the BackfillMessage that contains this item.
 * Optionally, the reaction can target a specific part by specifying TargetPart.
 * If not specified, the first part (sorted lexicographically) is targeted.
 */
export interface BackfillReaction {
  /**
   * Optional part of the message that the reaction targets.
   * If nil, the reaction targets the first part of the message.
   */
  TargetPart?: any /* networkid.PartID */;
  /**
   * Optional timestamp for the reaction.
   * If unset, the reaction will have a fake timestamp that is slightly after the message timestamp.
   */
  Timestamp: string /* RFC3339 */;
  Sender: EventSender;
  EmojiID: any /* networkid.EmojiID */;
  Emoji: string;
  ExtraContent: { [key: string]: any};
  DBMetadata: any;
}
/**
 * BackfillMessage is an individual message in a history pagination request.
 */
export interface BackfillMessage {
  ConvertedMessage?: ConvertedMessage;
  Sender: EventSender;
  ID: any /* networkid.MessageID */;
  TxnID: any /* networkid.TransactionID */;
  Timestamp: string /* RFC3339 */;
  StreamOrder: number /* int64 */;
  Reactions: (BackfillReaction | undefined)[];
  ShouldBackfillThread: boolean;
  LastThreadMessage: any /* networkid.MessageID */;
}
/**
 * FetchMessagesResponse contains the response for a message history pagination request.
 */
export interface FetchMessagesResponse {
  /**
   * The messages to backfill. Messages should always be sorted in chronological order (oldest to newest).
   */
  Messages: (BackfillMessage | undefined)[];
  /**
   * The next cursor to use for fetching more messages.
   */
  Cursor: any /* networkid.PaginationCursor */;
  /**
   * Whether there are more messages that can be backfilled.
   * This field is required. If it is false, FetchMessages will not be called again.
   */
  HasMore: boolean;
  /**
   * Whether the batch contains new messages rather than old ones.
   * Cursor, HasMore and the progress fields will be ignored when this is present.
   */
  Forward: boolean;
  /**
   * When sending forward backfill (or the first batch in a room), this field can be set
   * to mark the messages as read immediately after backfilling.
   */
  MarkRead: boolean;
  /**
   * Should the bridge check each message against the database to ensure it's not a duplicate before bridging?
   * By default, the bridge will only drop messages that are older than the last bridged message for forward backfills,
   * or newer than the first for backward.
   */
  AggressiveDeduplication: boolean;
  /**
   * Approximate backfill progress as a number between 0 and 1.
   */
  ApproxProgress: number /* float64 */;
  /**
   * Approximate number of messages remaining that can be backfilled.
   */
  ApproxRemainingCount: number /* int */;
  /**
   * Approximate total number of messages in the chat.
   */
  ApproxTotalCount: number /* int */;
  /**
   * An optional function that is called after the backfill batch has been sent.
   */
  CompleteCallback: any;
}
/**
 * BackfillingNetworkAPI is an optional interface that network connectors can implement to support backfilling message history.
 */
export type BackfillingNetworkAPI =
    NetworkAPI;
/**
 * BackfillingNetworkAPIWithLimits is an optional interface that network connectors can implement to customize
 * the limit for backwards backfilling tasks. It is recommended to implement this by reading the MaxBatchesOverride
 * config field with network-specific keys for different room types.
 */
export type BackfillingNetworkAPIWithLimits =
    BackfillingNetworkAPI;
/**
 * EditHandlingNetworkAPI is an optional interface that network connectors can implement to handle message edits.
 */
export type EditHandlingNetworkAPI =
    NetworkAPI;
export type PollHandlingNetworkAPI =
    NetworkAPI;
/**
 * ReactionHandlingNetworkAPI is an optional interface that network connectors can implement to handle message reactions.
 */
export type ReactionHandlingNetworkAPI =
    NetworkAPI;
/**
 * RedactionHandlingNetworkAPI is an optional interface that network connectors can implement to handle message deletions.
 */
export type RedactionHandlingNetworkAPI =
    NetworkAPI;
/**
 * ReadReceiptHandlingNetworkAPI is an optional interface that network connectors can implement to handle read receipts.
 */
export type ReadReceiptHandlingNetworkAPI =
    NetworkAPI;
/**
 * ChatViewingNetworkAPI is an optional interface that network connectors can implement to handle viewing chat status.
 */
export type ChatViewingNetworkAPI =
    NetworkAPI;
/**
 * TypingHandlingNetworkAPI is an optional interface that network connectors can implement to handle typing events.
 */
export type TypingHandlingNetworkAPI =
    NetworkAPI;
export type MarkedUnreadHandlingNetworkAPI =
    NetworkAPI;
export type MuteHandlingNetworkAPI =
    NetworkAPI;
export type TagHandlingNetworkAPI =
    NetworkAPI;
/**
 * RoomNameHandlingNetworkAPI is an optional interface that network connectors can implement to handle room name changes.
 */
export type RoomNameHandlingNetworkAPI =
    NetworkAPI;
/**
 * RoomAvatarHandlingNetworkAPI is an optional interface that network connectors can implement to handle room avatar changes.
 */
export type RoomAvatarHandlingNetworkAPI =
    NetworkAPI;
/**
 * RoomTopicHandlingNetworkAPI is an optional interface that network connectors can implement to handle room topic changes.
 */
export type RoomTopicHandlingNetworkAPI =
    NetworkAPI;
export interface ResolveIdentifierResponse {
  /**
   * Ghost is the ghost of the user that the identifier resolves to.
   * This field should be set whenever possible. However, it is not required,
   * and the central bridge module will not try to create a ghost if it is not set.
   */
  Ghost?: Ghost;
  /**
   * UserID is the user ID of the user that the identifier resolves to.
   */
  UserID: MautrixBridgeV2NetworkID.UserID;
  /**
   * UserInfo contains the info of the user that the identifier resolves to.
   * If both this and the Ghost field are set, the central bridge module will
   * automatically update the ghost's info with the data here.
   */
  UserInfo?: UserInfo;
  /**
   * Chat contains info about the direct chat with the resolved user.
   * This field is required when createChat is true in the ResolveIdentifier call,
   * and optional otherwise.
   */
  Chat?: CreateChatResponse;
}
export interface CreateChatResponse {
  PortalKey: any /* networkid.PortalKey */;
  /**
   * Portal and PortalInfo are not required, the caller will fetch them automatically based on PortalKey if necessary.
   */
  Portal?: Portal;
  PortalInfo?: ChatInfo;
}
/**
 * IdentifierResolvingNetworkAPI is an optional interface that network connectors can implement to support starting new direct chats.
 */
export type IdentifierResolvingNetworkAPI =
    NetworkAPI;
/**
 * GhostDMCreatingNetworkAPI is an optional extension to IdentifierResolvingNetworkAPI for starting chats with pre-validated user IDs.
 */
export type GhostDMCreatingNetworkAPI =
    IdentifierResolvingNetworkAPI;
/**
 * ContactListingNetworkAPI is an optional interface that network connectors can implement to provide the user's contact list.
 */
export type ContactListingNetworkAPI =
    NetworkAPI;
export type UserSearchingNetworkAPI =
    IdentifierResolvingNetworkAPI;
export type GroupCreatingNetworkAPI =
    IdentifierResolvingNetworkAPI;
export interface MembershipChangeType {
  From: any /* event.Membership */;
  To: any /* event.Membership */;
  IsSelf: boolean;
}
export type GhostOrUserLogin = any;
export interface MatrixMembershipChange {
  MatrixRoomMeta: MatrixRoomMeta<any /* event.MemberEventContent */ | undefined>;
  Target: GhostOrUserLogin;
  Type: MembershipChangeType;
  /**
   * Deprecated: Use Target instead
   */
  TargetGhost?: Ghost;
  /**
   * Deprecated: Use Target instead
   */
  TargetUserLogin?: UserLogin;
}
export type MembershipHandlingNetworkAPI =
    NetworkAPI;
export interface SinglePowerLevelChange {
  OrigLevel: number /* int */;
  NewLevel: number /* int */;
  NewIsSet: boolean;
}
export interface UserPowerLevelChange {
  Target: GhostOrUserLogin;
  SinglePowerLevelChange: SinglePowerLevelChange;
}
export interface MatrixPowerLevelChange {
  MatrixRoomMeta: MatrixRoomMeta<MautrixEvent.PowerLevelsEventContent | undefined>;
  Users: { [key: MautrixID.UserID]: UserPowerLevelChange | undefined};
  Events: { [key: string]: SinglePowerLevelChange | undefined};
  UsersDefault?: SinglePowerLevelChange;
  EventsDefault?: SinglePowerLevelChange;
  StateDefault?: SinglePowerLevelChange;
  Invite?: SinglePowerLevelChange;
  Kick?: SinglePowerLevelChange;
  Ban?: SinglePowerLevelChange;
  Redact?: SinglePowerLevelChange;
}
export type PowerLevelHandlingNetworkAPI =
    NetworkAPI;
export type PushType = number /* int */;
export const PushTypeUnknown: PushType = 0;
export const PushTypeWeb: PushType = 1;
export const PushTypeAPNs: PushType = 2;
export const PushTypeFCM: PushType = 3;
export interface WebPushConfig {
  vapid_key: string;
}
export interface FCMPushConfig {
  sender_id: string;
}
export interface APNsPushConfig {
  bundle_id: string;
}
export interface PushConfig {
  web?: WebPushConfig;
  fcm?: FCMPushConfig;
  apns?: APNsPushConfig;
  /**
   * If Native is true, it means the network supports registering for pushes
   * that are delivered directly to the app without the use of a push relay.
   */
  native?: boolean;
}
/**
 * PushableNetworkAPI is an optional interface that network connectors can implement
 * to support waking up the wrapper app using push notifications.
 */
export type PushableNetworkAPI =
    NetworkAPI;
/**
 * PushParsingNetwork is an optional interface that network connectors can implement
 * to support parsing native push notifications from networks.
 */
export type PushParsingNetwork =
    NetworkConnector;
export type RemoteEventType = number /* int */;
export const RemoteEventUnknown: RemoteEventType = 0;
export const RemoteEventMessage: RemoteEventType = 1;
export const RemoteEventMessageUpsert: RemoteEventType = 2;
export const RemoteEventEdit: RemoteEventType = 3;
export const RemoteEventReaction: RemoteEventType = 4;
export const RemoteEventReactionRemove: RemoteEventType = 5;
export const RemoteEventReactionSync: RemoteEventType = 6;
export const RemoteEventMessageRemove: RemoteEventType = 7;
export const RemoteEventReadReceipt: RemoteEventType = 8;
export const RemoteEventDeliveryReceipt: RemoteEventType = 9;
export const RemoteEventMarkUnread: RemoteEventType = 10;
export const RemoteEventTyping: RemoteEventType = 11;
export const RemoteEventChatInfoChange: RemoteEventType = 12;
export const RemoteEventChatResync: RemoteEventType = 13;
export const RemoteEventChatDelete: RemoteEventType = 14;
export const RemoteEventBackfill: RemoteEventType = 15;
/**
 * RemoteEvent represents a single event from the remote network, such as a message or a reaction.
 * When a [NetworkAPI] receives an event from the remote network, it should convert it into a [RemoteEvent]
 * and pass it to the bridge for processing using [Bridge.QueueRemoteEvent].
 */
export type RemoteEvent = any;
export type RemoteEventWithUncertainPortalReceiver =
    RemoteEvent;
export type RemotePreHandler =
    RemoteEvent;
export type RemotePostHandler =
    RemoteEvent;
export type RemoteChatInfoChange =
    RemoteEvent;
export type RemoteChatResync =
    RemoteEvent;
export type RemoteChatResyncWithInfo =
    RemoteChatResync;
export type RemoteChatResyncBackfill =
    RemoteChatResync;
export type RemoteChatResyncBackfillBundle =
    RemoteChatResyncBackfill;
export type RemoteBackfill =
    RemoteEvent;
export type RemoteDeleteOnlyForMe =
    RemoteEvent;
export type RemoteChatDelete =
    RemoteDeleteOnlyForMe;
export type RemoteEventThatMayCreatePortal =
    RemoteEvent;
export type RemoteEventWithTargetMessage =
    RemoteEvent;
export type RemoteEventWithBundledParts =
    RemoteEventWithTargetMessage;
export type RemoteEventWithTargetPart =
    RemoteEventWithTargetMessage;
export type RemoteEventWithTimestamp =
    RemoteEvent;
export type RemoteEventWithStreamOrder =
    RemoteEvent;
export type RemoteMessage =
    RemoteEvent;
export interface UpsertResult {
  SubEvents: RemoteEvent[];
  SaveParts: boolean;
  ContinueMessageHandling: boolean;
}
export type RemoteMessageUpsert =
    RemoteMessage;
export type RemoteMessageWithTransactionID =
    RemoteMessage;
export type RemoteEdit =
    RemoteEventWithTargetMessage;
export type RemoteReaction =
    RemoteEventWithTargetMessage;
export interface ReactionSyncUser {
  Reactions: (BackfillReaction | undefined)[];
  /**
   * Whether the list contains all reactions the user has sent
   */
  HasAllReactions: boolean;
  /**
   * If the list doesn't contain all reactions from the user,
   * then this field can be set to remove old reactions if there are more than a certain number.
   */
  MaxCount: number /* int */;
}
export interface ReactionSyncData {
  Users: { [key: MautrixBridgeV2NetworkID.UserID]: ReactionSyncUser | undefined};
  /**
   * Whether the map contains all users who have reacted to the message
   */
  HasAllUsers: boolean;
}
export type RemoteReactionSync =
    RemoteEventWithTargetMessage;
export type RemoteReactionWithExtraContent =
    RemoteReaction;
export type RemoteReactionWithMeta =
    RemoteReaction;
export type RemoteReactionRemove =
    RemoteEventWithTargetMessage;
export type RemoteMessageRemove =
    RemoteEventWithTargetMessage;
/**
 * Deprecated: Renamed to RemoteReadReceipt.
 */
export type RemoteReceipt = RemoteReadReceipt;
export type RemoteReadReceipt =
    RemoteEvent;
export type RemoteDeliveryReceipt =
    RemoteEvent;
export type RemoteMarkUnread =
    RemoteEvent;
export type RemoteTyping =
    RemoteEvent;
export type TypingType = number /* int */;
export const TypingTypeText: TypingType = 0;
export const TypingTypeUploadingMedia: TypingType = 1;
export const TypingTypeRecordingMedia: TypingType = 2;
export type RemoteTypingWithType =
    RemoteTyping;
export interface OrigSender {
  User?: User;
  UserID: MautrixID.UserID;
  RequiresDisambiguation: boolean;
  DisambiguatedName: string;
  FormattedName: string;
  MemberEventContent: any /* event.MemberEventContent */;
}
export interface MatrixEventBase<ContentType extends any> {
  /**
   * The raw event being bridged.
   */
  Event?: MautrixEvent.Event;
  /**
   * The parsed content struct of the event. Custom fields can be found in Event.Content.Raw.
   */
  Content: ContentType;
  /**
   * The room where the event happened.
   */
  Portal?: Portal;
  /**
   * The original sender user ID. Only present in case the event is being relayed (and Sender is not the same user).
   */
  OrigSender?: OrigSender;
  InputTransactionID: any /* networkid.RawTransactionID */;
}
export interface MatrixMessage {
  MatrixEventBase: MatrixEventBase<any /* event.MessageEventContent */ | undefined>;
  ThreadRoot?: any /* database.Message */;
  ReplyTo?: any /* database.Message */;
}
export interface MatrixEdit {
  MatrixEventBase: MatrixEventBase<any /* event.MessageEventContent */ | undefined>;
  EditTarget?: any /* database.Message */;
}
export interface MatrixPollStart {
  MatrixMessage: MatrixMessage;
  Content?: any /* event.PollStartEventContent */;
}
export interface MatrixPollVote {
  MatrixMessage: MatrixMessage;
  VoteTo?: any /* database.Message */;
  Content?: any /* event.PollResponseEventContent */;
}
export interface MatrixReaction {
  MatrixEventBase: MatrixEventBase<any /* event.ReactionEventContent */ | undefined>;
  TargetMessage?: any /* database.Message */;
  PreHandleResp?: MatrixReactionPreResponse;
  /**
   * When EmojiID is blank and there's already an existing reaction, this is the old reaction that is being overridden.
   */
  ReactionToOverride?: any /* database.Reaction */;
  /**
   * When MaxReactions is >0 in the pre-response, this is the list of previous reactions that should be preserved.
   */
  ExistingReactionsToKeep: (any /* database.Reaction */ | undefined)[];
}
export interface MatrixReactionPreResponse {
  SenderID: MautrixBridgeV2NetworkID.UserID;
  EmojiID: any /* networkid.EmojiID */;
  Emoji: string;
  MaxReactions: number /* int */;
}
export interface MatrixReactionRemove {
  MatrixEventBase: MatrixEventBase<any /* event.RedactionEventContent */ | undefined>;
  TargetReaction?: any /* database.Reaction */;
}
export interface MatrixMessageRemove {
  MatrixEventBase: MatrixEventBase<any /* event.RedactionEventContent */ | undefined>;
  TargetMessage?: any /* database.Message */;
}
export interface MatrixRoomMeta<ContentType extends any> {
  MatrixEventBase: MatrixEventBase<ContentType>;
  PrevContent: ContentType;
}
export type MatrixRoomName = MatrixRoomMeta<any /* event.RoomNameEventContent */ | undefined>;
export type MatrixRoomAvatar = MatrixRoomMeta<any /* event.RoomAvatarEventContent */ | undefined>;
export type MatrixRoomTopic = MatrixRoomMeta<any /* event.TopicEventContent */ | undefined>;
export interface MatrixReadReceipt {
  Portal?: Portal;
  /**
   * The event ID that the receipt is targeting
   */
  EventID: MautrixID.EventID;
  /**
   * The exact message that was read. This may be nil if the event ID isn't a message.
   */
  ExactMessage?: any /* database.Message */;
  /**
   * The timestamp that the user has read up to. This is either the timestamp of the message
   * (if one is present) or the timestamp of the receipt.
   */
  ReadUpTo: string /* RFC3339 */;
  /**
   * The ReadUpTo timestamp of the previous message
   */
  LastRead: string /* RFC3339 */;
  /**
   * The receipt metadata.
   */
  Receipt: any /* event.ReadReceipt */;
}
export interface MatrixTyping {
  Portal?: Portal;
  IsTyping: boolean;
  Type: TypingType;
}
export interface MatrixViewingChat {
  /**
   * The portal that the user is viewing. This will be nil when the user switches to a chat from a different bridge.
   */
  Portal?: Portal;
}
export type MatrixMarkedUnread = MatrixRoomMeta<any /* event.MarkedUnreadEventContent */ | undefined>;
export type MatrixMute = MatrixRoomMeta<any /* event.BeeperMuteEventContent */ | undefined>;
export type MatrixRoomTag = MatrixRoomMeta<any /* event.TagEventContent */ | undefined>;

//////////
// source: portal.go

export interface Portal {
  Portal?: any /* database.Portal */;
  Bridge?: Bridge;
  Log: any /* zerolog.Logger */;
  Parent?: Portal;
  Relay?: UserLogin;
}
export interface ChatInfoChange {
  /**
   * The chat info that changed. Any fields that did not change can be left as nil.
   */
  ChatInfo?: ChatInfo;
  /**
   * A list of member changes.
   * This list should only include changes, not the whole member list.
   * To resync the whole list, use the field inside ChatInfo.
   */
  MemberChanges?: ChatMemberList;
}
/**
 * Deprecated: Renamed to ChatInfo
 */
export type PortalInfo = ChatInfo;
export interface ChatMember {
  EventSender: EventSender;
  Membership: any /* event.Membership */;
  Nickname?: string;
  PowerLevel?: number /* int */;
  UserInfo?: UserInfo;
  PrevMembership: any /* event.Membership */;
}
export interface ChatMemberList {
  /**
   * Whether this is the full member list.
   * If true, any extra members not listed here will be removed from the portal.
   */
  IsFull: boolean;
  /**
   * Should the bridge call IsThisUser for every member in the list?
   * This should be used when SenderLogin can't be filled accurately.
   */
  CheckAllLogins: boolean;
  /**
   * The total number of members in the chat, regardless of how many of those members are included in MemberMap.
   */
  TotalMemberCount: number /* int */;
  /**
   * For DM portals, the ID of the recipient user.
   * This field is optional and will be automatically filled from MemberMap if there are only 2 entries in the map.
   */
  OtherUserID: MautrixBridgeV2NetworkID.UserID;
  /**
   * Deprecated: Use MemberMap instead to avoid duplicate entries
   */
  Members: ChatMember[];
  MemberMap: { [key: MautrixBridgeV2NetworkID.UserID]: ChatMember};
  PowerLevels?: PowerLevelOverrides;
}
export interface PowerLevelOverrides {
  Events: { [key: MautrixEvent.Type]: number /* int */};
  UsersDefault?: number /* int */;
  EventsDefault?: number /* int */;
  StateDefault?: number /* int */;
  Invite?: number /* int */;
  Kick?: number /* int */;
  Ban?: number /* int */;
  Redact?: number /* int */;
  Custom: any;
}
/**
 * Deprecated: renamed to PowerLevelOverrides
 */
export type PowerLevelChanges = PowerLevelOverrides;
export interface ChatInfo {
  Name?: string;
  Topic?: string;
  Avatar?: Avatar;
  Members?: ChatMemberList;
  JoinRule?: any /* event.JoinRulesEventContent */;
  Type?: any /* database.RoomType */;
  Disappear?: any /* database.DisappearingSetting */;
  ParentID?: any /* networkid.PortalID */;
  UserLocal?: UserLocalPortalInfo;
  CanBackfill: boolean;
  ExtraUpdates: ExtraUpdater<Portal | undefined>;
}
export type ExtraUpdater<T extends any> = any;
export interface UserLocalPortalInfo {
  /**
   * To signal an indefinite mute, use [event.MutedForever] as the value here.
   * To unmute, set any time before now, e.g. [bridgev2.Unmuted].
   */
  MutedUntil?: string /* RFC3339 */;
  Tag?: any /* event.RoomTag */;
}

//////////
// source: portalbackfill.go


//////////
// source: portalinternal.go

export type PortalInternals = Portal;

//////////
// source: portalreid.go

export type ReIDResult = number /* int */;
export const ReIDResultError: ReIDResult = 0;
export const ReIDResultNoOp: ReIDResult = 1;
export const ReIDResultSourceDeleted: ReIDResult = 2;
export const ReIDResultSourceReIDd: ReIDResult = 3;
export const ReIDResultTargetDeletedAndSourceReIDd: ReIDResult = 4;
export const ReIDResultSourceTombstonedIntoTarget: ReIDResult = 5;

//////////
// source: simpleremoteevent.go

/**
 * SimpleRemoteEvent is a simple implementation of RemoteEvent that can be used with struct fields and some callbacks.
 * Using this type is only recommended for simple bridges. More advanced ones should implement
 * the remote event interfaces themselves by wrapping the remote network library event types.
 * Deprecated: use the types in the simplevent package instead.
 */
export interface SimpleRemoteEvent<T extends any> {
  Type: RemoteEventType;
  LogContext: any;
  PortalKey: any /* networkid.PortalKey */;
  Data: T;
  CreatePortal: boolean;
  ID: any /* networkid.MessageID */;
  Sender: EventSender;
  TargetMessage: any /* networkid.MessageID */;
  EmojiID: any /* networkid.EmojiID */;
  Emoji: string;
  ReactionDBMeta: any;
  Timestamp: string /* RFC3339 */;
  ChatInfoChange?: ChatInfoChange;
  ResyncChatInfo?: ChatInfo;
  ResyncBackfillNeeded: boolean;
  BackfillData?: FetchMessagesResponse;
  ConvertMessageFunc: any;
  ConvertEditFunc: any;
}

//////////
// source: user.go

export interface User {
  User?: any /* database.User */;
  Bridge?: Bridge;
  Log: any /* zerolog.Logger */;
  CommandState: any /* unsafe.Pointer */;
  Permissions: any /* bridgeconfig.Permissions */;
}

//////////
// source: userlogin.go

export interface UserLogin {
  UserLogin?: any /* database.UserLogin */;
  Bridge?: Bridge;
  User?: User;
  Log: any /* zerolog.Logger */;
  Client: NetworkAPI;
  BridgeState?: BridgeStateQueue;
}
export interface NewLoginParams {
  LoadUserLogin: any;
  DeleteOnConflict: boolean;
  DontReuseExisting: boolean;
}
export interface DeleteOpts {
  LogoutRemote: boolean;
  DontCleanupRooms: boolean;
  BlockingCleanup: boolean;
}
