// Code generated by tygo. DO NOT EDIT.
import * as MautrixID from "../../id/index.ts"
import * as MautrixBridgeV2 from "../../bridgev2/index.ts"
import * as MautrixEvent from "../../event/index.ts"
import * as MautrixBridgeV2Commands from "../../bridgev2/commands/index.ts"
import * as MautrixBridgeV2NetworkID from "../../bridgev2/networkid/index.ts"
import * as MautrixBridgeStatus from "../../bridge/status/index.ts"
import * as BeeperSDKBridgesTypes from "../../../../../github.com/beeper/beeper-client-sdk/pkg/bridges/types/index.ts"
//////////
// source: connector.go

export type Crypto = any;
export interface Connector {
  AS?: any /* appservice.AppService */;
  Bot?: any /* appservice.IntentAPI */;
  StateStore?: any /* sqlstatestore.SQLStateStore */;
  Crypto: Crypto;
  Log?: any /* zerolog.Logger */;
  Config?: any /* bridgeconfig.Config */;
  Bridge?: MautrixBridgeV2.Bridge;
  Provisioning?: ProvisioningAPI;
  DoublePuppet?: doublePuppetUtil;
  MediaProxy?: any /* mediaproxy.MediaProxy */;
  MediaConfig: any /* mautrix.RespMediaConfig */;
  SpecVersions?: any /* mautrix.RespVersions */;
  Capabilities?: MautrixBridgeV2.MatrixCapabilities;
  IgnoreUnsupportedServer: boolean;
  EventProcessor?: any /* appservice.EventProcessor */;
  Websocket: boolean;
  OnWebsocketReplaced: any;
}

//////////
// source: crypto.go

export interface CryptoHelper {
}

//////////
// source: cryptostore.go

export interface SQLCryptoStore {
  SQLCryptoStore?: any /* crypto.SQLCryptoStore */;
  UserID: MautrixID.UserID;
  GhostIDFormat: string;
}

//////////
// source: directmedia.go

export const MediaIDPrefix = "\u{0001F408}";
export const MediaIDTruncatedHashLength = 16;
export const ContentURIMaxLength = 255;

//////////
// source: doublepuppet.go


//////////
// source: intent.go

/**
 * ASIntent implements the bridge ghost API interface using a real Matrix homeserver as the backend.
 */
export interface ASIntent {
  Matrix?: any /* appservice.IntentAPI */;
  Connector?: Connector;
}

//////////
// source: matrix.go

export type CommandProcessor = any;

//////////
// source: provisioning.go

export interface ProvisioningAPI {
  Router?: never;
  /**
   * GetAuthFromRequest is a custom function for getting the auth token from
   * the request if the Authorization header is not present.
   */
  GetAuthFromRequest: any;
  /**
   * GetUserIDFromRequest is a custom function for getting the user ID to
   * authenticate as instead of using the user ID provided in the query
   * parameter.
   */
  GetUserIDFromRequest: any;
}
export interface ProvLogin {
  ID: string;
  Process: MautrixBridgeV2.LoginProcess;
  NextStep?: MautrixBridgeV2.LoginStep;
  Override?: MautrixBridgeV2.UserLogin;
  Lock: never;
}
export const ProvisioningKeyRequest = "fi.mau.provision.request";
export type IProvisioningAPI = any;
export interface RespWhoami {
  network: MautrixBridgeV2.BridgeName;
  login_flows: MautrixBridgeV2.LoginFlow[];
  homeserver: string;
  bridge_bot: MautrixID.UserID;
  command_prefix: string;
  management_room?: MautrixID.RoomID;
  logins: RespWhoamiLogin[];
}
export interface RespWhoamiLogin {
  /**
   * Deprecated
   */
  state_event: MautrixBridgeStatus.BridgeStateEvent;
  /**
   * Deprecated
   */
  state_ts: string /* jsontime.Unix */;
  /**
   * Deprecated
   */
  state_reason?: string;
  /**
   * Deprecated
   */
  state_info?: { [key: string]: any};
  state: MautrixBridgeStatus.BridgeState;
  id: MautrixBridgeV2NetworkID.UserLoginID;
  name: string;
  profile: MautrixBridgeStatus.RemoteProfile;
  space_room?: MautrixID.RoomID;
}
export interface RespLoginFlows {
  flows: MautrixBridgeV2.LoginFlow[];
}
export interface RespSubmitLogin {
  login_id: string;
  LoginStep?: MautrixBridgeV2.LoginStep;
}
export interface RespGetLogins {
  login_ids: MautrixBridgeV2NetworkID.UserLoginID[];
}
export type WritableError = any;
export interface RespResolveIdentifier {
  id: MautrixBridgeV2NetworkID.UserID;
  name?: string;
  avatar_url?: MautrixID.ContentURIString;
  identifiers?: string[];
  mxid?: MautrixID.UserID;
  dm_room_mxid?: MautrixID.RoomID;
}
export interface RespGetContactList {
  contacts: (RespResolveIdentifier | undefined)[];
}
export interface ReqSearchUsers {
  query: string;
}
export interface RespSearchUsers {
  results: (RespResolveIdentifier | undefined)[];
}

//////////
// source: websocket.go
